<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Pizza 365 | Drinks</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">


  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Vũ Duy Dũng</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="indexVoucher2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="indexMenu2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Drinks</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Drink</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h3 class="text-center text-primary">Quản trị Drinks</h3>
        <div class="jumbotron">
            <div class="row form-group">
                <label for="" class="col-sm-3">Mã Nước Uống</label>
                <div class="col-sm-9">
                    <input id="inp-drink-code" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Tên Nước Uống</label>
                <div class="col-sm-9">
                    <input id="inp-drink-name" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Đơn giá</label>
                <div class="col-sm-9">
                    <input id="inp-price" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ghi chú</label>
                <div class="col-sm-9">
                    <input id="inp-note" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ngày tạo</label>
                <div class="col-sm-9">
                    <input id="inp-create-date" type="date" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ngày sửa</label>
                <div class="col-sm-9">
                    <input id="inp-update-date" type="date" class="form-control">
                </div>
            </div>
            <button id="btn-add" class="btn btn-success">Thêm mới</button>
            <button id="btn-update" class="btn btn-primary" style="display: none;">Cập nhật</button>
            <button id="btn-delete" class="btn btn-danger" style="display: none;">Xóa Drink</button>
            
        </div>
        <table id="table-drinks" class="table table-bordered table-stripped table-hover">
              <thead>
                  <tr>
                      <th>STT</th>
                      <th>Mã Nước Uống</th>
                      <th>Tên Nước Uống</th>
                      <th>Đơn Giá</th>
                      <th>Ghi Chú</th>
                      <th>Ngày Tạo</th>
                      <th>Ngày Cập Nhật</th>
  
                  </tr>
              </thead>
              <tbody></tbody>
          </table>
        
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
    <!-- Modal delete -->
<div class="modal fade" id="modal-delete" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <h5>Bạn có chắc chắn muốn xóa loại nước này?</h5>
        </div>
        <div class="modal-footer">
          <button id="btn-confirm" type="button" class="btn btn-primary">Xác nhận</button>
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
        </div>
      </div>
    </div>
  </div>
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
  var gTableDrinks = $("#table-drinks").DataTable({
      columns: [
          { data: "id"},
          { data: "maNuocUong"},
          { data: "tenNuocUong"},
          { data: "donGia"},
          { data: "ghiChu"},
          { data: "ngayTao"},
          { data: "ngayCapNhat"}
      ],
      columnDefs: [
          {
              targets: 0,
              render: function() {
                  return gStt++;
              }
          }
      ]
  });

  var gStt = 1;
  var gDrinkId = null;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();

  // Thực thi sự kiện nhấn vào row trong datatable
  $("#table-drinks").on("click", "tr", function() {
      onClickRow(this);
  });

  // Thực thi sự kiện nhấn nút tạo mới drink 
  $("#btn-add").on("click", function(){
      onBtnAddNewClick();
  });

  // Thực thi sự kiện nhấn nút cập nhật drink 
  $("#btn-update").on("click", function(){
      onBtnUpdateClick();
  });

  // Thực thi sự kiện nhấn nút xóa voucher 
  $("#btn-delete").on("click", function(){
      $("#modal-delete").modal("show");
  });

  // Thực thi sự kiện xác nhận xóa trong modal delete
  $("#btn-confirm").on("click", function() {
      onBtnDeleteClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
      callApiToLoadListDrinks();
  }

  // Hàm sự kiện nhấn vào row drink
  function onClickRow(paramRow) {
      var vDataRow = gTableDrinks.row(paramRow).data();
      $("#inp-drink-code").val(vDataRow.maNuocUong);
      $("#inp-drink-name").val(vDataRow.tenNuocUong);
      $("#inp-note").val(vDataRow.ghiChu);
      $("#inp-price").val(vDataRow.donGia);
      $("#inp-create-date").val(formatDate(vDataRow.ngayTao));
      if(vDataRow.ngayCapNhat != null) {
          $("#inp-update-date").val(formatDate(vDataRow.ngayCapNhat));
      }
      else {
          $("#inp-update-date").val(vDataRow.ngayCapNhat);
      }

      $("#btn-add").hide();
      $("#btn-update").show();
      $("#btn-delete").show();
      gDrinkId = vDataRow.id;
  }


  // Hàm xử lý sự kiện nhấn nút thêm mới drink
  function onBtnAddNewClick() {
      var vDrink = {
          maNuocUong: "",
          tenNuocUong: "",
          donGia: "",
          ghiChu: ""
      }

      getData(vDrink);
      console.log(vDrink)
      var vValidate = validateData(vDrink);
      if(vValidate) {
          callApiToCreateNew(vDrink);
      }
  }

  // Hàm xử lý sự kiện nhấn nút sửa 1 drinks
  function onBtnUpdateClick() {
      var vDrink = {
          maNuocUong: "",
          tenNuocUong: "",
          donGia: "",
          ghiChu: ""
      }

      getData(vDrink);
      console.log(vDrink)
      var vValidate = validateData(vDrink);
      if(vValidate) {
          callApiToUpdate(vDrink);
      }
  }

  // Hàm nhấn nút delete drink
  function onBtnDeleteClick() {
      $.ajax({
          type: "DELETE",
          url: "http://localhost:8080/drinks/" + gDrinkId,
          success: function(paramRes) {
              alert("Drink đã bị xóa!");
              callApiToLoadListDrinks();
              resetForm();
              $("#modal-delete").modal("hide");
          },
          error: function(paramError) {
              console.log(paramError.status);
              alert("Xóa drink thất bại, vui lòng thử lại!");
              $("#modal-delete").modal("hide");
          }
      })
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  // Hàm gọi APi để load dữ liệu Drink vào table
  function callApiToLoadListDrinks() {
      $.ajax({
          type: "GET",
          url: "http://localhost:8080/drinks",
          success: function(paramRes) {
              console.log(paramRes);
              loadDataToTable(paramRes);
          },
          error: function(paramError) {
              console.log(paramError.status);
          }
      })
  }

  // Hàm load dữ liệu vào table
  function loadDataToTable(paramVoucherData) {
      gStt = 1;
      gTableDrinks.clear();
      gTableDrinks.rows.add(paramVoucherData);
      gTableDrinks.draw();
  }

  // Hàm format lại ngày tháng
  function formatDate(paramDate) {
      var vDate = paramDate.split("-");
      return vDate[2]+ "-" + vDate[1] + "-" + vDate[0];
  }

  // Hàm lấy dữ liệu voucher từ form
  function getData(paramVoucherData) {
      paramVoucherData.maNuocUong = $("#inp-drink-code").val();
      paramVoucherData.tenNuocUong = $("#inp-drink-name").val();
      paramVoucherData.donGia = $("#inp-price").val();
      paramVoucherData.ghiChu = $("#inp-note").val();
  }

  // Hàm validate dữ liệu
  function validateData(paramData) {
      if(paramData.maNuocUong == "") {
          alert("Vui lòng nhập mã nước uống!");
          return false;
      }
      if(paramData.tenNuocUong == "") {
          alert("Vui lòng nhập tên nước uống");
          return false;
      }
      if(paramData.donGia == "") {
          alert("Vui lòng nhập giá tiền");
          return false;
      }
      if(paramData.donGia < 5000 || paramData.phanTramGiamGia >= 1000000 ) {
          alert("Giá tiền chưa phù hợp!");
          return false;
      }

      return true;
  }

  // Hàm gọi api để thêm mới drink  
  function callApiToCreateNew(paramData) {
      $.ajax({
          type: "POST",
          url: "http://localhost:8080/drinks",
          contentType: "application/json",
          data: JSON.stringify(paramData),
          success: function(paramRes) {
              alert("Tạo mới thành công!");
              resetForm();
              callApiToLoadListDrinks();
          }, 
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }

  // Hàm reset form 
  function resetForm() {
      $("#inp-drink-code").val("");
      $("#inp-drink-name").val("");
      $("#inp-price").val("");
      $("#inp-note").val("");
      $("#inp-create-date").val("");
      $("#inp-update-date").val("");


      $("#btn-add").show();
      $("#btn-update").hide();
      $("#btn-delete").hide();
  }

  // Hàm gọi API để sửa 1 drink
  function callApiToUpdate(paramData) {
      $.ajax({
          type: "PUT",
          url: "http://localhost:8080/drinks/" + gDrinkId,
          contentType: "application/json",
          data: JSON.stringify(paramData),
          success: function(paramRes) {
              alert("Cập nhật thành công!");
              resetForm();
              callApiToLoadListDrinks();
          }, 
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }


</script>
</body>
</html>
